Index: cpukit/include/rtems/score/mrspimpl.h
===================================================================
--- cpukit/include/rtems/score/mrspimpl.h	(revision b817de6d475018e532fe43e89312e155a433b384)
+++ cpukit/include/rtems/score/mrspimpl.h	(revision 0b1bfab89f37276ff96c2bd75df04ad17c45994f)
@@ -1,2 +1,10 @@
+/**
+ * @file
+ *
+ * @ingroup RTEMSScoreMRSP
+ *
+ * @brief Definitions for Multiprocessor Resource Sharing Protocol (MrsP) Implementation.
+ */
+
 /*
  * Copyright (c) 2014, 2016 embedded brains GmbH.  All rights reserved.
@@ -38,4 +46,10 @@
 #define MRSP_TQ_OPERATIONS &_Thread_queue_Operations_priority_inherit
 
+/**
+ * @brief Acquires critical accordingt to MrsP.
+ *
+ * @param mrsp The MrsP control for the operation.
+ * @param queue_context The thread queue context.
+ */
 RTEMS_INLINE_ROUTINE void _MRSP_Acquire_critical(
   MRSP_Control         *mrsp,
@@ -46,4 +60,10 @@
 }
 
+/**
+ * @brief Releases according to MrsP.
+ *
+ * @param mrsp The MrsP control for the operation.
+ * @param queue_context The thread queue context.
+ */
 RTEMS_INLINE_ROUTINE void _MRSP_Release(
   MRSP_Control         *mrsp,
@@ -54,4 +74,11 @@
 }
 
+/**
+ * @brief Gets owner of the MrsP control.
+ *
+ * @param mrsp The MrsP control to get the owner from.
+ *
+ * @return The owner of the Mrsp control.
+ */
 RTEMS_INLINE_ROUTINE Thread_Control *_MRSP_Get_owner(
   const MRSP_Control *mrsp
@@ -61,4 +88,10 @@
 }
 
+/**
+ * @brief Sets owner of the MrsP control.
+ *
+ * @param[out] mrsp The MrsP control to set the owner of.
+ * @param owner The desired new owner for @a mrsp.
+ */
 RTEMS_INLINE_ROUTINE void _MRSP_Set_owner(
   MRSP_Control   *mrsp,
@@ -69,4 +102,12 @@
 }
 
+/**
+ * @brief Gets priority of the MrsP control.
+ *
+ * @param mrsp The mrsp to get the priority from.
+ * @param scheduler The corresponding scheduler.
+ *
+ * @return The priority of the MrsP control.
+ */
 RTEMS_INLINE_ROUTINE Priority_Control _MRSP_Get_priority(
   const MRSP_Control      *mrsp,
@@ -80,4 +121,11 @@
 }
 
+/**
+ * @brief Sets priority of the MrsP control
+ *
+ * @param[out] mrsp The MrsP control to set the priority of.
+ * @param schedulger The corresponding scheduler.
+ * @param new_priority The new priority for the MrsP control
+ */
 RTEMS_INLINE_ROUTINE void _MRSP_Set_priority(
   MRSP_Control            *mrsp,
@@ -92,4 +140,17 @@
 }
 
+/**
+ * @brief Adds the priority to the given thread.
+ *
+ * @param mrsp The MrsP control for the operation.
+ * @param[in, out] thread The thread to add the priority node to.
+ * @param[out] priority_node The priority node to initialize and add to
+ *      the thread.
+ * @param queue_context The thread queue context.
+ *
+ * @retval STATUS_SUCCESSFUL The operation succeeded.
+ * @retval STATUS_MUTEX_CEILING_VIOLATED The wait priority of the thread
+ *      exceeds the ceiling priority.
+ */
 RTEMS_INLINE_ROUTINE Status_Control _MRSP_Raise_priority(
   MRSP_Control         *mrsp,
@@ -127,4 +188,11 @@
 }
 
+/**
+ * @brief Removes the priority from the given thread.
+ *
+ * @param[in, out] The thread to remove the priority from.
+ * @param priority_node The priority node to remove from the thread
+ * @param queue_context The thread queue context.
+ */
 RTEMS_INLINE_ROUTINE void _MRSP_Remove_priority(
   Thread_Control       *thread,
@@ -141,4 +209,12 @@
 }
 
+/**
+ * @brief Replaces the given priority node with the ceiling priority of
+ *      the MrsP control.
+ *
+ * @param mrsp The mrsp control for the operation.
+ * @param[out] thread The thread to replace the priorities.
+ * @param ceiling_priority The node to be replaced.
+ */
 RTEMS_INLINE_ROUTINE void _MRSP_Replace_priority(
   MRSP_Control   *mrsp,
@@ -158,4 +234,15 @@
 }
 
+/**
+ * @brief Claims ownership of the MrsP control.
+ *
+ * @param mrsp The MrsP control to claim the ownership of.
+ * @param[in, out] executing The currently executing thread.
+ * @param queue_context The thread queue context.
+ *
+ * @retval STATUS_SUCCESSFUL The operation succeeded.
+ * @retval STATUS_MUTEX_CEILING_VIOLATED The wait priority of the executing
+ *      thread exceeds the ceiling priority.
+ */
 RTEMS_INLINE_ROUTINE Status_Control _MRSP_Claim_ownership(
   MRSP_Control         *mrsp,
@@ -187,4 +274,18 @@
 }
 
+/**
+ * @brief Initializes a MrsP control.
+ *
+ * @param[out] mrsp The MrsP control that is initialized.
+ * @param scheduler The scheduler for the operation.
+ * @param ceiling_priority
+ * @param executing The currently executing thread.  Ignored in this method.
+ * @param initially_locked Indicates whether the MrsP control shall be initally
+ *      locked. If it is initially locked, this method returns STATUS_INVALID_NUMBER.
+ *
+ * @retval STATUS_SUCCESSFUL The operation succeeded.
+ * @retval STATUS_INVALID_NUMBER The MrsP control is initially locked.
+ * @retval STATUS_NO_MEMORY There is not enough memory to allocate.
+ */
 RTEMS_INLINE_ROUTINE Status_Control _MRSP_Initialize(
   MRSP_Control            *mrsp,
@@ -226,4 +327,17 @@
 }
 
+/**
+ * @brief Waits for the ownership of the MrsP control.
+ *
+ * @param[in, out] mrsp The MrsP control to get the ownership of.
+ * @param[in, out] executing The currently executing thread.
+ * @param queue_context the thread queue context.
+ *
+ * @retval STATUS_SUCCESSFUL The operation succeeded.
+ * @retval STATUS_MUTEX_CEILING_VIOLATED The wait priority of the
+ *      currently executing thread exceeds the ceiling priority.
+ * @retval STATUS_DEADLOCK A deadlock occured.
+ * @retval STATUS_TIMEOUT A timeout occured.
+ */
 RTEMS_INLINE_ROUTINE Status_Control _MRSP_Wait_for_ownership(
   MRSP_Control         *mrsp,
@@ -284,4 +398,18 @@
 }
 
+/**
+ * @brief Seizes the MrsP control.
+ *
+ * @param[in, out] mrsp The MrsP control to seize the control of.
+ * @param[in, out] executing The currently executing thread.
+ * @param wait Indicates whether the calling thread is willing to wait.
+ * @param queue_context The thread queue context.
+ *
+ * @retval STATUS_SUCCESSFUL The operation succeeded.
+ * @retval STATUS_MUTEX_CEILING_VIOLATED The wait priority of the executing
+ *      thread exceeds the ceiling priority.
+ * @retval STATUS_UNAVAILABLE The executing thread is already the owner of
+ *      the MrsP control.  Seizing it is not possible.
+ */
 RTEMS_INLINE_ROUTINE Status_Control _MRSP_Seize(
   MRSP_Control         *mrsp,
@@ -313,4 +441,14 @@
 }
 
+/**
+ * @brief Surrenders the MrsP control.
+ *
+ * @param[in, out] mrsp The MrsP control to surrender the control of.
+ * @param[in, out] executing The currently executing thread.
+ * @param queue_context The thread queue context.
+ *
+ * @retval STATUS_SUCCESSFUL The operation succeeded.
+ * @retval STATUS_NOT_OWNER The executing thread does not own the MrsP control.
+ */
 RTEMS_INLINE_ROUTINE Status_Control _MRSP_Surrender(
   MRSP_Control         *mrsp,
@@ -355,4 +493,14 @@
 }
 
+/**
+ * @brief Checks if the MrsP control can be destroyed.
+ *
+ * @param mrsp The MrsP control for the operation.
+ *
+ * @retval STATUS_SUCCESSFUL The MrsP is currently not used
+ *      and can be destroyed.
+ * @retval STATUS_RESOURCE_IN_USE The MrsP control is in use,
+ *      it cannot be destroyed.
+ */
 RTEMS_INLINE_ROUTINE Status_Control _MRSP_Can_destroy( MRSP_Control *mrsp )
 {
@@ -364,4 +512,10 @@
 }
 
+/**
+ * @brief Destroys the MrsP control
+ *
+ * @param[in, out] The mrsp that is about to be destroyed.
+ * @param queue_context The thread queue context.
+ */
 RTEMS_INLINE_ROUTINE void _MRSP_Destroy(
   MRSP_Control         *mrsp,
